N = 100; %Number of grid points (J in textbook)
x = 0:1/(N-1):1; %values of x at grid points
dx = 1/(N-1); %Spatial step
s=0.45;  %<0.5 for stability
dt = s*dx^2; %Time step for stability

T = 0.1; %Final time
M = floor(T/dt); %Number of iterations

u0 = double(x>0.5); %Initial heat distribution

ymin = min(u0);
ymax = max(u0);

u=u0;


%Press any key to stop/start simulation
for i=1:M
    
    un = [u(2:end),0]; %u(i+1)
    up = [0,u(1:end-1)]; %u(i-1)
    
    uxx = (un - 2*u + up)/dx^2;
    u = u + dt*uxx;
    

end
